#ifndef DATAFILE_H
#define DATAFILE_H

#include <string>
#include <vector>

#include "Common.h"
#include "array.h"

class Datafile {
public:
    Datafile();
    Datafile(FILE* fp);
    Datafile(const char* filename);
    virtual ~Datafile();

    bool Open(FILE* fp);
    bool Open(const char* filename);
    int NumColumns() const { return ncol; }
    int NumRows() const { return nrow; }

    const char* GetFilename() { return fname; }
    const std::string& GetHeader() { return header; }
    const std::string& GetFooter() { return footer; }

    const array& GetColumn(int j);
    std::vector<real> GetRow(int i) const;

protected:
    const char* fname;
    std::string header;
    std::string footer;

    typedef std::vector<array> ArrayList;
    ArrayList columns;
    int ncol;
    int nrow;
};

#endif // DATAFILE_H
